C     THIS PROGRAM READS, REARRANGES, & OUTPUTS DATA IN EPIC FMT
C     MODAWTHC.FOR
      CHARACTER*4 HED
	CHARACTER*8 ASTN,FNAM
	DIMENSION HED(7)
	DIMENSION NC(13),NTX(12),KR(6),IDG(3),IX(3),KW(3)
	DIMENSION SMY(150),RMO(12),RST(12),SDTN(12),SDTX(12),SMN(12),SMX
     &(12),WTDA(12),X(12)
	DIMENSION OBMN(12,150),OBMX(12,150),PCP(12,150),PRW(2,12) 
	DATA HED/' PCP','SDPC','WTDA',' TMX',' TMN','SDTX','SDTN'/
	DATA KR/11,12,13,14,15,16/,KW/21,22,23/
	DATA NC/0,31,60,91,121,152,182,213,244,274,305,335,366/,IDG/1,2,3/
	OPEN(KR(1),FILE='RDWTRUN.DAT')
   12 READ(KR(1),5)FNAM,ASTN,B1,B2
      FNAM=ADJUSTR(FNAM)
	ASTN=ADJUSTR(ASTN)
      IF(FNAM.EQ.'        ')GO TO 3
	OPEN(KR(2),FILE=FNAM//".PCP")
	OPEN(KR(3),FILE=FNAM//".WTD")
	OPEN(KR(4),FILE=FNAM//".TMX")
	OPEN(KR(5),FILE=FNAM//".TMN")
	OPEN(KR(6),FILE=FNAM//".EXT")
	OPEN(KW(1),FILE=ASTN//".DLY")
	OPEN(KW(2),FILE=ASTN//".OUT")
	OPEN(KW(3),FILE=ASTN//".WP1")
	IX(1)=748932582
      IX(2)=1985072130
      IX(3)=1631331038
	WRITE(KW(2),319)
	WRITE(KW(3),5)ASTN
	WRITE(KW(3),5)'        '
	READ(KR(6),*)SDTX
	READ(KR(6),*)SDTN
	J=0
	NTX=0
    1 J=J+1
      READ(KR(4),*,END=2)IYR,(OBMX(I,J),I=1,12)
	READ(KR(5),*)IYR,(OBMN(I,J),I=1,12)
	DO 4 I=1,12
	IF(OBMX(I,J).GT.900..OR.OBMN(I,J).GT.900.)GO TO 4
	SMX(I)=SMX(I)+OBMX(I,J)
     	SMN(I)=SMN(I)+OBMN(I,J)
	NTX(I)=NTX(I)+1
    4 CONTINUE
      GO TO 1
    2 SUM=0.
      TOT=0.
      DO I=1,12
	XN=NTX(I)
      SMX(I)=SMX(I)/XN
      SMN(I)=SMN(I)/XN
	TOT=TOT+SMX(I)
	SUM=SUM+SDTX(I)
	END DO
      DO 7 I=1,12
	IF(SDTX(I).GT.900..OR.SDTN(I).GT.900.)GO TO 18
	IF(TOT>SUM)GO TO 7
     	SDTX(I)=(SDTX(I)-SMX(I))*.33
      SDTN(I)=(SMN(I)-SDTN(I))*.33
      GO TO 7
   18 SDTX(I)=AMAX1(.5,5.8-.09*SMX(I))
      SDTN(I)=AMAX1(.5,5.2-.13*SMN(I))
    7 CONTINUE
	WRITE(KW(2),9)HED(4),SMX,HED(5),SMN,HED(6),SDTX,HED(7),SDTN
     	J=0
	WTDA=0.
	RMO=0.
   11 J=J+1
      READ(KR(3),*,END=10)IYR,X
	DO 8 I=1,12
    8	WTDA(I)=WTDA(I)+X(I)
      GO TO 11
   10	XYR=J-1
      DO 17 I=1,12
   17	WTDA(I)=WTDA(I)/XYR
      WRITE(KW(2),9)HED(3),WTDA
    	J=0
   14 J=J+1
	READ(KR(2),*,END=15)IYR,(PCP(I,J),I=1,12)
	IF(J.EQ.1)IYR0=IYR
	SMY(J)=0.
	DO 16 I=1,12
	RMO(I)=RMO(I)+PCP(I,J)
   16 SMY(J)=SMY(J)+PCP(I,J)
	GO TO 14
   15 NBYR=J-1
      XYR=NBYR
	DO 13 I=1,12
      RMO(I)=RMO(I)/XYR
	XM=NC(I+1)-NC(I)
      PRW(1,I)=B1*(WTDA(I)+.0001)/XM
      PRW(2,I)=1.-B1+PRW(1,I)
      RST(I)=RMO(I)/(WTDA(I)+.01)
   13 WTDA(I)=WTDA(I)/XM
	CALL BSIM(HED,PRW,OBMX,OBMN,PCP,SMY,RMO,RST,SDTN,SDTX,SMN,SMX,WTDA
     &,B2,NC,KR,KW,IX,IDG,NBYR,IYR0)
	DO I=2,6
	CLOSE(KR(I))
	END DO
	DO I=1,3
	CLOSE(KW(I))
	END DO 
	GO TO 12
    3	DO I=1,6
	CLOSE(KR(I))
	END DO
	DO I=1,3
	CLOSE(KW(I))
	END DO  
    	STOP
    5 FORMAT(2A8,2F8.0)
    6 FORMAT(2X,3I4,6X,6F6.2)
    9 FORMAT(1X,A4,12F8.2)
  319 FORMAT(/T11,'JAN',5X,'FEB',5X,'MAR',5X,'APR',5X,'MAY',5X,'JUN',5X,
     &'JUL',5X,'AUG',5X,'SEP',5X,'OCT',5X,'NOV',5X,'DEC')
      END
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-*
      FUNCTION ADSTN(RN1,RN2)
C     THIS SUBPROGRAM COMPUTES A STANDARD NORMAL DEVIATE GIVEN TWO RANDOM
C     NUMBERS
      ADSTN=SQRT(-2.*ALOG(RN1))*COS(6.283185*RN2)
      RETURN
      END
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-*
      SUBROUTINE AICL(JDA,KDA,MO,NC,NYD)
C     THIS SUBPROGRAM COMPUTES THE DAY OF THE MONTH, GIVEN THE MONTH AND
C     THE DAY OF THE YEAR.
      DIMENSION NC(13)
      IF(MO.GT.2)GO TO 2
      KDA=JDA-NC(MO)
      GO TO 3
    2 KDA=JDA-NC(MO)+NYD
    3 RETURN
      END
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-*
      SUBROUTINE ALPYR(IYR,NYD,LPYR)
      NYD=1
      IF(MOD(IYR,100).NE.0)GO TO 1
      IF(MOD(IYR,400).NE.0)GO TO 2
      GO TO 3
    1 IF(MOD(IYR,4).NE.0)GO TO 2
    3 NYD=LPYR
    2 RETURN 
      END
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-*
      FUNCTION AUNIF(IX,J)
	DIMENSION IX(3)
      K=IX(J)/127773
      IX(J)=16807*(IX(J)-K*127773)-K*2836
      IF(IX(J).LT.0)IX(J)=IX(J)+2147483647
      AUNIF=IX(J)*4.656612875D-10
      RETURN
      END
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-*
      SUBROUTINE AXMON(JDX,MOX,NYD,NC)
C     EPIC3050
C     THIS SUBPROGRAM DETERMINES THE MONTH, GIVEN THE DAY OF THE YEAR.
      DIMENSION NC(13)
      IF(JDX.LE.NC(2))GO TO 3
      M=MOX
      DO 2 MOX=M,12
      M1=MOX+1
      NDA=NC(M1)-NYD
      IF(JDX.LE.NDA)GO TO 4
    2 CONTINUE
    3 MOX=1
    4 RETURN
      END
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-*
      SUBROUTINE BSIM(HED,PRW,OBMX,OBMN,PCP,SMY,RMO,RST,SDTN,SDTX,SMN,
     &SMX,WTDA,B2,NC,KR,KW,IX,IDG,NBYR,IYR0)
C     THIS SUBPROGRAM DRIVES THE DAILY SIMULATION.
      CHARACTER*4 HED
      CHARACTER*5 ACK
	DIMENSION HED(7)
      DIMENSION NC(13),KDY(12),KWT(12),MOF(12),IDG(3),IX(3),KR(3),KW(3)
      DIMENSION OBMN(12,150),OBMX(12,150),PCP(12,150),PRW(2,12)
	DIMENSION SMY(150),RFV(31),TMN(31),TMX(31),PD(12),PW(12),RMO(12),
     &RST(12),SDTN(12),SDTX(12),SMN(12),SMX(12),SN(12),SP(12),SSN(12),
     &SSP(12),SSSP(12),SSX(12),SX(12),WTDA(12),X(12),XRD(12),XTD(12),
     &WX(2)
	DATA LPYR/0/,IXP/0/,MOF/31,29,31,30,31,30,31,31,30,31,30,31/
	STDV(SX,SX2,XN)=SQRT((SX2-SX*SX/XN)/(XN-1.)+1.E-10)
      SKCF(XN,SX,SX2,SX3,SDV)=(SX3*XN*XN-3.*XN*SX*SX2+2.*SX**3)/(XN*(XN-
     11.)*(XN-2.)*SDV**3)
	V1=AUNIF(IX,IDG(2))
	WRITE(KW(2),15)
   15 FORMAT(//3X,'YR  MO',3X,'PCPI',6X,'PCPS',6X,'TMXI',6X,'TMXS',6X,
     &'TMNI',6X,'TMNS')
	KDY=0
	KWT=0 
	PD=0.
	PW=0.
	SX=0.
	SN=0.
	SP=0.
	SSX=0.
	SSN=0.
	SSP=0.
	SSSP=0.
	XRD=0.
	XTD=0.
	MO1=1
	MO=1
	IYR=IYR0
      DO 87 IY=1,NBYR	 
      JDA=1
      CALL ALPYR(IYR,NYD,LPYR)
      ND=366-NYD
	SUM=0.
	TOT=0.
	SM1=0.
	SM2=0.
C     BEGIN DAILY SIMULATION.
      DO 84 IDA=1,ND
      CALL AICL(IDA,KDA,MO,NC,NYD)
      XDA=KDA
	RFV(KDA)=0.
	IF(PCP(MO1,IY).GT..01)CALL WRWD(PRW,RFV,RST,IDG,IX,KDA,
     &MO1)
C	WRITE(KW(2),6)IYR,MO,KDA,RFV(KDA)
	SUM=SUM+RFV(KDA)
	CALL WGN(RFV,SMN,SMX,WTDA,WX,TXXM,V1,B2,IDG,IX,MO,KDA)
      CALL WTAIR(TMN,TMX,SDTN,SDTX,SMN,WX,TXXM,IX,IDG,MO,KDA)
	SM1=SM1+TMX(KDA)
     	SM2=SM2+TMN(KDA)
      JDA=IDA+1
      CALL AXMON(JDA,MO,NYD,NC)
      IF(MO.EQ.MO1)GO TO 84
	NN=MOF(MO1)
	IF(MO1.EQ.2)NN=NN-NYD
	XTD(MO1)=XTD(MO1)+NN
	IF(PCP(MO1,IY).LT..01)GO TO 10
    7	IF(SUM.GT..01)GO TO 18 
	SUM=0.
	DO 17 I=1,NN
	CALL WRWD(PRW,RFV,RST,IDG,IX,I,MO1)
   17 SUM=SUM+RFV(I)
      GO TO 7
   18 CFP=PCP(MO1,IY)/SUM
     	DO 3 I=1,NN
      RFV(I)=RFV(I)*CFP
    3 CONTINUE
   10 XN=NN 
      AD1=0.
	AD2=0.
	IF(OBMX(MO1,IY).LT.900..AND.OBMN(MO1,IY).LT.900.)GO TO 11
      CFX=1.
	CFN=1.
	GO TO 12 
   11	CFX=OBMX(MO1,IY)-SM1/XN
	CFN=XN*(OBMX(MO1,IY)-OBMN(MO1,IY))/(SM1-SM2)
   12 DO 8 I=1,NN
	X1=TMX(I)-TMN(I)
	TMX(I)=TMX(I)+CFX
      TMN(I)=TMX(I)-CFN*X1
	AD1=AD1+TMX(I)
	AD2=AD2+TMN(I)
	SSX(MO1)=SSX(MO1)+TMX(I)*TMX(I)
	SSN(MO1)=SSN(MO1)+TMN(I)*TMN(I)
	IF(RFV(I).GT.1.E-5)GO TO 19
	RFV(I)=0. 
	GO TO 130
   19 IF(IXP.EQ.0)GO TO 110
      KWT(MO1)=KWT(MO1)+1
      GO TO 120
  110 KDY(MO1)=KDY(MO1)+1
  120 IXP=1
      TOT=TOT+RFV(I)
     	RR=RFV(I)*RFV(I)
      SSP(MO1)=SSP(MO1)+RR
	SSSP(MO1)=SSSP(MO1)+RR*RFV(I)
	XRD(MO1)=XRD(MO1)+1.
	GO TO 16
  130 IXP=0
   16	ACK='     '
	IF(TMN(I).GT.TMX(I))ACK='*****'
    8 WRITE(KW(1),6)IYR,MO1,I,TMX(I),TMN(I),RFV(I),ACK
      SX(MO1)=SX(MO1)+AD1
	SN(MO1)=SN(MO1)+AD2
	SP(MO1)=SP(MO1)+TOT
      AD1=AD1/XN
	AD2=AD2/XN
      WRITE(KW(2),1)IYR,MO1,PCP(MO1,IY),TOT,OBMX(MO1,IY),AD1,OBMN(MO1,
     1IY),AD2
      IF(MO.LT.MO1)WRITE(KW(2),9)IYR,SMY(IY)
      MO1=MO
      SUM=0.
	TOT=0.
	SM1=0.
	SM2=0.
   84 CONTINUE
      MO=1
      IYR=IYR+1
   87 CONTINUE
      X2=NBYR
      DO 13 I=1,12
	SSX(I)=STDV(SX(I),SSX(I),XTD(I))
	SX(I)=SX(I)/XTD(I)
	SSN(I)=STDV(SN(I),SSN(I),XTD(I))
	SN(I)=SN(I)/XTD(I)
	IF(SP(I)>0.)THEN 
	X1=STDV(SP(I),SSP(I),XRD(I))
	SSSP(I)=SKCF(XRD(I),SP(I),SSP(I),SSSP(I),X1)
	ELSE
	X1=0.
	SSSP(I)=0.
	END IF
	SSP(I)=X1
	ZZ=KDY(I)
      PD(I)=ZZ/(XTD(I)-XRD(I))
      X1=KWT(I)
      PW(I)=X1/(XRD(I)+1.E-10)
	SP(I)=SP(I)/X2
   13 XRD(I)=XRD(I)/X2
      WRITE(KW(2),319)
      WRITE(KW(2),14)HED(3),XRD,HED(1),SP,HED(2),SSP,HED(4),SX,HED(6),
     &SSX,HED(5),SN,HED(7),SSN
	WRITE(KW(3),5)SX,'TMX'
      WRITE(KW(3),5)SN,'TMN'
      WRITE(KW(3),5)SSX,'SDMX'
      WRITE(KW(3),5)SSN,'SDMN'
      WRITE(KW(3),5)SP,'PRCP'
      WRITE(KW(3),5)SSP,'SDRF'
      WRITE(KW(3),4)SSSP,'SKRF'
      WRITE(KW(3),4)PD,'PW|D'
      WRITE(KW(3),4)PW,'PW|W'
      WRITE(KW(3),5)XRD,'DAYP'
	DO 20 I=1,5
      WRITE(KW(3),21)'        '
   20 CONTINUE
      RETURN
    1 FORMAT(1X,2I4,6F10.3)
    4 FORMAT(12F6.3,1X,A4)
    5 FORMAT(12F6.2,1X,A4)
    6 FORMAT(2X,3I4,6X,2F6.2,F6.1,20X,A5)
    9 FORMAT(1X,I4,F10.1)
   14 FORMAT(1X,A4,12F8.2)	 
   21 FORMAT(A8)
  319 FORMAT(/T11,'JAN',5X,'FEB',5X,'MAR',5X,'APR',5X,'MAY',5X,'JUN',5X,
     &'JUL',5X,'AUG',5X,'SEP',5X,'OCT',5X,'NOV',5X,'DEC')
      END
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-*
      SUBROUTINE WGN(RFV,SMN,SMX,WTDA,WX,TXXM,V1,B2,IDG,IX,MO,KDA)
C     THIS SUBPROGRAM SIMULATES DAILY PRECIPITATION, MAXIMUM AND MINUMUM
C     AIR TEMPERATURE
      DIMENSION IDG(3),IX(3)
      DIMENSION RFV(31),SMN(12),SMX(12),WTDA(12),WX(2),XIM(2)
	DIMENSION A(3,3), B(3,3), XX(3), E(3)
      DATA A/.594,.454,-.004,.076,.261,-.037,-.018,-.129,.222/,B/.767,.
     1304,.274,0.,.692,-.33,0.,0.,.873/,XIM/0.,0./
      XXX=B2*(SMX(MO)-SMN(MO))
      Z2=WTDA(MO)
      TXXM=SMX(MO)+XXX*Z2
      IF(RFV(KDA).LE.0.)GO TO 2
      TXXM=TXXM-XXX
    2 DO 3 I=1,3
      V2=AUNIF(IX,IDG(2))
      E(I)=ADSTN(V1,V2)
      V1=V2
    3 CONTINUE
      DO 4 I=1,2
      WX(I)=0.
      XX(I)=0.
      DO 4 J=1,2
      WX(I)=WX(I)+B(I,J)*E(J)
      XX(I)=XX(I)+A(I,J)*XIM(J)
    4 CONTINUE
      DO 5 I=1,2
      WX(I)=WX(I)+XX(I)
      XIM(I)=WX(I)
    5 CONTINUE
      RETURN
      END
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-*
      SUBROUTINE WRWD(PRW,RFV,RST,IDG,IX,KDA,MO)
	DIMENSION IDG(3),IX(3)
	DIMENSION PRW(2,12),RFV(31),RST(12)
	DATA LW/1/
      RN=1.-AUNIF(IX,IDG(1))
      IF(RN.GT.PRW(LW,MO)+.001)GO TO 4
      X1=AUNIF(IX,IDG(3))
      RFV(KDA)=RST(MO)*(-ALOG(X1))**1.3
	LW=2
      GO TO 5
    4 RFV(KDA)=0.
      LW=1
    5 RETURN
      END
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-*
      SUBROUTINE WTAIR(TMN,TMX,SDTN,SDTX,SMN,WX,TXXM,IX,IDG,MO,KDA)
	DIMENSION IDG(3),IX(3)
	DIMENSION TMN(31),TMX(31),SDTN(12),SDTX(12),SMN(12),WX(2)
	TMX(KDA)=TXXM+SDTX(MO)*WX(1)
      TMN(KDA)=SMN(MO)+SDTN(MO)*WX(2)
      IF(TMN(KDA).GT.TMX(KDA))TMN(KDA)=TMX(KDA)-.2*ABS(TMX(KDA))
      RETURN
      END